<?php

include "MyPDO.php";
include "VueCategorie.php";
include "bdd.php";

function getDebutHTML(): string {
    return "<!doctype html>
<html lang=\"fr\">
<head>
  <meta charset=\"utf-8\">
  <title>appli crud</title>
</head>
<body>
";
}

function getFinHTML(): string {
    return "<!-- contenu -->
</body>
</html>
";
}

session_start();

    // initialisation de la connexion via l'instance de MyPDO
$myPDOCategorie = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['passwd'], 'Categorie');

    // initialisation du générateur de vues HTML
$vue = new VueCategorie();

    // initialisation des chaînes à afficher
$contenu = "";
$message = "";

    // traitement des différentes actions possibles

/*if (isset($_GET['action']))
    switch ($_GET['action']) {
        case 'read':
            $categorie = $myPDOCategorie->get('id_categorie', $_GET['id_categorie']);
            $contenu .= $vue->getHTML4Categorie($categorie);
            $_SESSION['etat'] = 'lecture';
            break;
        case 'create':
            $nbCategorie = $myPDOCategorie->count();
            $contenu .= $vue->getFormulaire4Categorie(array('id_categorie' => array ('type'=>'number', 'default'=> $nbCategorie+1), 'robe_bouteille' => 'text', 'sucrage_bouteille' => 'text', 'type_bouteille' => 'text'));
            $_SESSION['etat'] = 'création';
            break;
        case 'update':
            $categorie = $myPDOCategorie->get('id_categorie',$_GET['id_categorie']);
            $contenu .= $vue->getFormulaire4Categorie(array('id_categorie'=>array('type'=>'number','default'=>$categorie->getId_Categorie()),
    'liv_titre'=>array('type'=>'text','default'=>$livre->getLivTitre()),
    'liv_depotlegal'=>array('type'=>'date','default'=>$livre->getLivDepotlegal())));
            $_SESSION['etat'] = 'modification';
            break;
        case 'delete':
            $myPDOLivre->delete(array('liv_num'=>$_GET['liv_num']));
            $_SESSION['etat'] = 'suppression';
            break;
        default:
            $message .= "<p>Action ".$_GET['action']." non implémentée.</p>\n";
    }

else
    if (isset($_SESSION['etat']))
        switch($_SESSION['etat']) {
            case 'création':
                $myPDOLivre->insert(array('liv_num'=>$_GET['liv_num'], 'liv_titre'=>$_GET['liv_titre'], 'liv_depotlegal'=>$_GET['liv_depotlegal']));
                $_SESSION['etat'] = 'créé';
                break;
            case 'modification':
                $myPDOLivre->update('liv_num', array('liv_num'=>$_GET['liv_num'], 'liv_titre'=>$_GET['liv_titre'], 'liv_depotlegal'=>$_GET['liv_depotlegal']));
                $_SESSION['etat'] = 'modifié';
                break;
            case 'suppression':
                $_SESSION['etat']= 'supprimé';
                break;
            case 'créé':
            case 'modifié':
            case 'supprimé':
            default:
                $_SESSION['etat'] = 'neutre';
        }*/


    // affichage du nombre total de catégories :
$nbCategorie = $myPDOCategorie->count();
$message .= "<p>La table Catégorie contient ".$nbCategorie." enregistrements.</p>\n";

    // sélection/modification/suppression/ d'un livre

    $contenu .=
        "<form action='?' method='GET'>
            <select name='action'>
            <option value='read'>Lire</option>
            <option value='update'>Modifier</option>
            <option value='delete'>Supprimer</option>
</select>
<input type='number' min='1' max='$nbCategorie' name='liv_num'/>
<input type='submit' name='envoi' value='Go' />
</form>\n";


    // création d'un nouveau livre
    // Attention suppose que le nombre de livre présent correspond au dernier identifiant attribué...
$contenu .="<p><a href='?action=create'>Créer livre ";
$contenu .= $nbCategorie+1;
$contenu .= "</a> </p>";

    // récupération et affichage de la liste des livres avec liens vers édition/suppresion

$lesCategories = $myPDOCategorie->getAll();
$contenu .= $vue->getAllCategorie($lesCategories);

    // Production de la page HTML
echo getDebutHTML();
echo $message;
echo $contenu;
echo getFinHTML();

?>